SystemOrganization addCategory: #'MC2-Issues-Core'!
SystemOrganization addCategory: #'MC2-Issues-Domain'!

MDElement subclass: #MDIssueElement
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Issues-Domain'!

!MDIssueElement class methodsFor: 'instance creation' stamp: 'jf 1/25/2010 20:17'!
id: aUUID
	^ self basicNew
		initializeWithId: aUUID;
		yourself! !

!MDIssueElement class methodsFor: 'instance creation' stamp: 'jf 1/25/2010 20:17'!
new
	self shouldNotImplement! !

!MDIssueElement methodsFor: 'dispatching' stamp: 'jf 1/19/2010 21:49'!
handleWith: anObject
	^ anObject handleIssue: self! !

!MDIssueElement methodsFor: 'initialization' stamp: 'jf 1/25/2010 20:14'!
initializeWithId: aUUID
	self initialize.
	id := aUUID! !

MDAdaptor subclass: #MDIssueAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Issues-Domain'!

!MDElementHandler methodsFor: '*mc2-issues' stamp: 'jf 1/31/2010 11:51'!
handleIssue: anIssueElement 
	^ self handleElement: anIssueElement! !

MDElementHandler subclass: #MDIssueAdaptionHandler
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Issues-Domain'!

!MDIssueAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/31/2010 11:48'!
database: anIssueDatabase
	^ self basicNew initializeWithDatabase: anIssueDatabase; yourself! !

!MDIssueAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/31/2010 11:47'!
new
	^ self database: MDIssueDatabase default! !

!MDIssueAdaptionHandler methodsFor: 'handling' stamp: 'jf 1/19/2010 22:57'!
handleIssue: anIssueElement
	^ MDIssueAdaptor forElement: anIssueElement! !

!MDIssueAdaptionHandler methodsFor: 'initialization' stamp: 'jf 1/31/2010 11:47'!
initializeWithDatabase: anIssueDatabase
	self initialize.
	database := anIssueDatabase! !

GRObject subclass: #MDIssue
	instanceVariableNames: 'title description status id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Issues-Core'!

!MDIssue class methodsFor: 'instance creation' stamp: 'jf 1/25/2010 20:08'!
new
	^ self withId: UUID new! !

!MDIssue class methodsFor: 'instance creation' stamp: 'jf 1/25/2010 20:08'!
withId: aUUID
	^ self basicNew initializeWithId: aUUID; yourself! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
description
	^ description! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
description: anObject
	description := anObject! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/25/2010 20:04'!
id
	^ id! !

!MDIssue methodsFor: 'initialization' stamp: 'jf 1/25/2010 20:07'!
initializeWithId: aUUID
	self initialize.
	id := aUUID.
	status := #new! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
status
	^ status! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
status: anObject
	status := anObject! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
title
	^ title! !

!MDIssue methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:15'!
title: anObject
	title := anObject! !

GRObject subclass: #MDIssueDatabase
	instanceVariableNames: 'issues'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'MC2-Issues-Core'!

!MDIssueDatabase class methodsFor: 'accessing' stamp: 'jf 1/31/2010 11:42'!
default
	^ Default ifNil: [Default := self new]! !

!MDIssueDatabase class methodsFor: 'initialize-release' stamp: 'jf 1/25/2010 20:10'!
unload
	Default := nil! !

!MDIssueDatabase methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:47'!
add: anIssue
	^ issues add: anIssue! !

!MDIssueDatabase methodsFor: 'initialization' stamp: 'jf 1/31/2010 11:42'!
initialize
	super initialize.
	issues := OrderedCollection new! !

!MDIssueDatabase methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:46'!
issues
	^ issues! !

!MDIssueDatabase methodsFor: 'accessing' stamp: 'jf 1/19/2010 20:47'!
remove: anIssue
	^ issues remove: anIssue! !

MDDomain subclass: #MDIssuesDomain
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Issues-Domain'!

!MDIssuesDomain methodsFor: 'public' stamp: 'jf 1/31/2010 11:48'!
adapt: anElement
	^ anElement handleWith: (MDIssueAdaptionHandler database: database)! !

!MDIssuesDomain methodsFor: 'testing' stamp: 'jf 1/19/2010 21:22'!
name
	^ #issues! !
